#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\Blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include <string.h>
#include <stdlib.h>

#include "resource.h"
//#include "resource\BitMapFont.h"
#include "resource\BGFont.h"

//BG3 eLXg
//BG2 
//---------------------------------------------------------------------------
#define TRUE  (1)
#define FALSE (0)

#define MODE_STATE_POSTION  1	//͈ʒüړ[h
#define MODE_STATE_WRITE    2	//ނ̊Jn[h

//---------------------------------------------------------------------------
typedef struct {
	u8  x;
	u8  y;
	u8  cx;
	u8  cy;
	u8  MinX;		//ړ
	u8  MinY;
	u8  MaxX;
	u8  MaxY;
	u16 SprNo;
	u16 SprTile;
	u16 SprSize;
	u16 SprForm;
} ST_CURSOR;

ST_CURSOR CursorPostion;		//͈ʒup̃J[\
ST_CURSOR CursorWrite;			//͗p̃J[\

u8 ModeState;		//MODE_STATE_POSTION or MODE_STATE_WRITE

u8 BG2Chr;
u8 BG2Map;
u8 BG2Col;
//---------------------------------------------------------------------------
void Init();
void InitCursor();

void DrawFrame();
void DrawChar();

void SRAMSave(u8, u8, u16);
void SRAMLoad();

void Input();
//---------------------------------------------------------------------------
int main(void)
{
	Init();
	InitCursor();

	DrawFrame();
	SRAMLoad();

	SetMode(MODE_0 | BG2_ENABLE | OBJ_ENABLE | OBJ_MAP_2D);

	for(;;)
	{
		Input();
	}
	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	//BG
	BG2Chr = 1;
	BG2Map = 0;
	BG2Col = 0;

	REG_BG2CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG2Chr) | BG_MAPBASE(BG2Map) | 0);

	BGSetPal16  (BG2Col, (u16*)BGFont_palette);
	BGSetChrData(BG2Chr, (u16*)BGFont_data, BGFont_DATA_SIZE);

	//Sprite
	SpriteInitialize();
	SpriteSetPal16((u16*)&cursor_pal_bin);
	SpriteSetData ((u16*)&cursor_img_bin, 32);
}
//---------------------------------------------------------------------------
void InitCursor()
{
	ModeState = MODE_STATE_POSTION;

	//͈ʒup̃J[\
	CursorPostion.x       = 0;
	CursorPostion.y       = 2;
	CursorPostion.cx      = 8;
	CursorPostion.cy      = 8;
	CursorPostion.MinX    = 0;			//ړ
	CursorPostion.MaxX    = 30-1;
	CursorPostion.MinY    = 2;
	CursorPostion.MaxY    = 17-1;
	CursorPostion.SprNo   = 0;
	CursorPostion.SprTile = 0;

	//͗p̃J[\
	CursorWrite.x         = 0;
	CursorWrite.y         = 18;
	CursorWrite.cx        = 8;
	CursorWrite.cy        = 8;
	CursorWrite.MinX      = 0;			//ړ
	CursorWrite.MaxX      = 30-1;
	CursorWrite.MinY      = 18;
	CursorWrite.MaxY      = 20-1;
	CursorWrite.SprNo     = 1;
	CursorWrite.SprTile   = 0;

	SpriteSetSize(0, SP_SIZE_8, SP_SQUARE, SP_COLOR_16);
	SpriteSetSize(1, SP_SIZE_8, SP_SQUARE, SP_COLOR_16);
	SpriteSetChr (0, 0);
	SpriteSetChr (1, 0);
	SpriteMove(0, CursorPostion.x*CursorPostion.cx, CursorPostion.y*CursorPostion.cy);
	SpriteMove(1, CursorWrite.x*CursorWrite.cx, CursorWrite.y*CursorWrite.cy);
}
//---------------------------------------------------------------------------
void DrawFrame()
{
	BGDrawStr(BG2Map, 0,  0, (u8*)" GBA Tiny Editer              ");
	BGDrawStr(BG2Map, 0,  1, (u8*)"------------------------------");
	BGDrawStr(BG2Map, 0, 17, (u8*)"------------------------------");
	BGDrawStr(BG2Map, 0, 18, (u8*)"abcdefghijklmnopqrstuvwxyz    ");
	BGDrawStr(BG2Map, 0, 19, (u8*)" +-*/%()[],;=&|=!  0123456789 ");
}
//---------------------------------------------------------------------------
void Input()
{
	ST_CURSOR *pCur;
	u8 Mode = ModeState;

	if(Mode == MODE_STATE_POSTION) pCur = &CursorPostion;
	else                           pCur = &CursorWrite;

	u8 Key;
	KeyInitialize();
	for(;;)
	{
		Key = KeyInput();
		
		if(Key & KEY_UP    && pCur->y > pCur->MinY)
		{
			pCur->y--; break;
		}
		if(Key & KEY_DOWN  && pCur->y < pCur->MaxY)
		{
			pCur->y++; break;
		}
		if(Key & KEY_LEFT  && pCur->x > pCur->MinX)
		{
			pCur->x--; break;
		}
		if(Key & KEY_RIGHT && pCur->x < pCur->MaxX)
		{
			pCur->x++; break;
		}
		if(Key & KEY_B)
		{
			if(Mode == MODE_STATE_POSTION) Mode = MODE_STATE_WRITE;
			else                           Mode = MODE_STATE_POSTION;
			break;
		}
		if(Key & KEY_A)
		{
			DrawChar();
		}
	} // for(;;)

	SpriteMove(pCur->SprNo, pCur->x * pCur->cx, pCur->y * pCur->cy);
	ModeState = Mode;

	while(*KEYS != 0x3ff){}		//͂ɂȂ܂ő҂
}
//---------------------------------------------------------------------------
void DrawChar()
{
	u16 chr = BGGetChar(BG2Map, CursorWrite.x, CursorWrite.y);
	BGDrawChar(BG2Map, CursorPostion.x, CursorPostion.y, 0, chr);

	SRAMSave(CursorPostion.x, CursorPostion.y, chr);

	//s̐܂Ԃ`
	CursorPostion.x++;
	if(CursorPostion.x * CursorPostion.cx >= 240)
	{
		CursorPostion.x = CursorPostion.MinX;
		CursorPostion.y++;
	}
	if(CursorPostion.y * CursorPostion.cy >= 160)
	{
		CursorPostion.y = CursorPostion.MaxY;
	}

	SpriteMove(0, CursorPostion.x*CursorPostion.cx, CursorPostion.y*CursorPostion.cy);
}
//---------------------------------------------------------------------------
void SRAMSave(u8 x, u8 y, u16 data)
{
	SRAMWrite16((u32)(x+y*30)*2, data);
}
//---------------------------------------------------------------------------
void SRAMLoad()
{
	u8 x,y;
	u16 data;
	for(y=CursorPostion.MinY; y<=CursorPostion.MaxY; y++)
	{
		for(x=CursorPostion.MinX; x<=CursorPostion.MaxX; x++)
		{
			data = SRAMRead16((u32)(x+y*30)*2);
			BGDrawChar(BG2Map, x, y, 0, data);
		}
	}
}
